package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"
)

func WrapProjectDataHandler(ctx *gin.Context) {
	handler := newProjectDataHandler(ctx)
	baseRun(handler)
}

type ProjectData struct {
	ctx  *gin.Context
	req  *http_model.ProjectDataRequest
	resp *http_model.CommonResponse
}

func (c ProjectData) getContext() *gin.Context {
	return c.ctx
}

func (c ProjectData) getResponse() interface{} {
	return c.resp
}

func (c ProjectData) getRequest() interface{} {
	return c.req
}

func (c ProjectData) run() {
	data := http_model.ProjectDataRequest{}
	data = *c.req
	//auth := middleware.GetSessionAuth(c.ctx)
	//enterpriseID := auth.EnterpriseID
	res, err := service.Project.Data(c.ctx, data)
	if err != nil {
		logrus.Errorf("[ProjectData] call ProjectData err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorParamCheck, "")
		logrus.Info("ProjectData fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功看数据"
	c.resp.Data = res
	c.resp.Status = consts.ErrorSuccess
}

func (c ProjectData) checkParam() error {
	return nil
}

func newProjectDataHandler(ctx *gin.Context) *ProjectData {
	return &ProjectData{
		ctx:  ctx,
		req:  http_model.NewProjectDataRequest(),
		resp: http_model.NewProjectDataResponse(),
	}
}
